Camera 	= require "camera"         	-- Camera controls
--gooi = require "gooi"

function love.load()
	coords = {}
	eqns = {"cos(x)", "0.1*x+1", "(x-4)*(x-4)+1" }
	sin, cos, tan = math.sin, math.cos, math.tan
	step = 0.1
	c = 0
    camera = Camera(0, 0, 80)
    for i, v in pairs(eqns) do
    	drawLine(v)
    end
end

function love.update(dt)
	-- Camera controls
	if love.keyboard.isDown("right") then
	    camera:move(0.5, 0)
	elseif love.keyboard.isDown("left") then
		camera:move(-0.5, 0)
	elseif love.keyboard.isDown("up") then
		camera:move(0, -0.5)
	elseif love.keyboard.isDown("down") then
		camera:move(0, 0.5)
	elseif love.keyboard.isDown("z") then
		camera:zoom(1.1)
	elseif love.keyboard.isDown("x") then
		camera:zoom(0.9)
	end
end

function love.draw()
	love.graphics.print(tostring(love.timer.getFPS( )), 10, 10, 0, 0.2)
	love.graphics.setColor(255,255,255)
	camera:attach()
	love.graphics.setLineWidth( 0.05 )
		   love.graphics.setColor(255,255,255)
		   love.graphics.line(-1000, 0, 1000, 0)
   		   love.graphics.line(0, -1000, 0, 1000)
		   love.graphics.setColor(255,0,255)
		   -- For all lines in coords table, draw 'em
		   for i,v in ipairs(coords) do
		   		love.graphics.line(v)
		   end
	    love.graphics.setFont(love.graphics.newFont("pixel.ttf", 60))
	    love.graphics.push()
	    	love.graphics.setColor(255,255,255)
		    love.graphics.scale(0.002, 0.002)
	    	-- Draw x,y axis numbers, scale up by 500 because size = 0.002
			for i=-100, 100, 1 do love.graphics.print("-  " .. i*-1, 10, i*500) end
			for i=-100, 100, 1 do love.graphics.print(i, i*500, 10) end
	    love.graphics.pop()
	camera:detach()
    --gooi.draw()
end

function drawLine( expression )
	-- For each new line, increment c
	c = c + 1
	-- Create a new keyed array with value of c
	-- i.e. c = 1, coords = { [1]={1,2,3,4,...} }
    coords[c] = {}
    -- Range values of x, from -n to n
    for i=-30, 30, step do
    	-- Replace x in equation with i
		local eqn = string.gsub(expression, "x", i)
		-- Calculate output
      	func = assert(loadstring("return " .. eqn))
      	-- Invert y-coord because love2d axis is flipped
        y = func()*-1
        -- Insert into lines relative array
        table.insert(coords[c], i)
        table.insert(coords[c], y)
    end
end